<template>
    <div class="order-request-execution">
      <ObForm
        v-if="parentModal.visible"
        :form-model="formModel"
        :form-data="formData"
        ok-text="Изменить"
        :is-loading="isLoading"
        data-qa="ChangeTarifModal"
        @submit="onSubmitHandler"
      >
        <div class="row row-inputs">
          <div class="col-xs-12">
            <ObInput
              label="Точка погрузки"
              :value="dataSource.addressTitle"
              :readonly="true"
              :pre-icon="'pin'"
              data-qa="addressFrom"

            />
          </div>
        </div>
        <div class="title">Укажите новый слот</div>
        <div class="row row-inputs">
          <div class="col-xs-6">
            <ObDatePicker
              v-model="formData.plannedSlotStartAt"
              label="Текущее начало слота"
              :is-time="true"
              :readonly="true"
              data-qa="datetime"
            />
          </div>
          <div class="col-xs-6">
            <ObDatePicker
              v-model="formData.plannedSlotEndAt"
              label="Текущее окончание слота"
              :is-time="true"
              :readonly="true"
              data-qa="datetime"
            />
          </div>
        </div>
        <div class="row row-inputs">
          <div class="col-xs-6">
            <ObDatePicker
              v-model="formData.slotStart"
              label="Новое начало слота"
              :is-time="true"
              data-qa="datetime"
              property="slotStart"
            />
          </div>
          <div class="col-xs-6">
            <ObDatePicker
              v-model="formData.slotEnd"
              label="Новое окончание слота"
              :is-time="true"
              data-qa="datetime"
              property="slotEnd"
            />
          </div>
        </div>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import moment from 'moment'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'

const fromDateLarger = (value, vm) => {
  return Boolean(vm && (moment(vm.slotEnd).diff(moment(value)) >= 0 || !vm.slotEnd))
}

const toDateUnder = (value, vm) => {
  return Boolean(vm && (moment(vm.slotStart).diff(moment(value)) <= 0 || !vm.slotStart))
}

const isFuture = (value, vm) => {
  return Boolean(vm && (moment(value).diff(moment()) > 0))
}

const prevPointLarger = (value, vm) => {
  return Boolean(vm && vm.prevPoint && (moment(vm.slotStart).diff(moment(vm.prevPoint.plannedSlotEndAt)) > 0) || !vm.prevPoint)
}

const isToUnderLastPoint = (value, vm) => {
  const lastPoint = vm?.points[vm?.points.length - 1] || {}
  const { plannedSlotStartAt } = lastPoint
  const isLastPoint = vm?.uuid === lastPoint.uuid
  return Boolean(isLastPoint || moment(value).diff(moment(plannedSlotStartAt)) < 0)
}

export default {
  name: 'ChangeSlotModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObInput,
    ObDatePicker,
    ObUploader
  },
  props: {
    prevPoint: {
      type: Object,
      default: null
    },
    points: {
      type: Array,
      default: () => []
    }
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    formModel () {
      let _self = this
      return {
        uuid: {
          value: ''
        },
        plannedSlotStartAt: {
          value: () => _self.dataSource.plannedSlotStartAt
        },
        plannedSlotEndAt: {
          value: () => _self.dataSource.plannedSlotEndAt
        },
        fileUuid: {
          value: ''
        },
        slotStart: {
          value: '',
          validator: {
            required,
            prevPointLarger: {
              method: prevPointLarger,
              error: 'Дата должна быть позже даты предыдущего слота'
            },
            isToUnderLastPoint: {
              method: isToUnderLastPoint,
              error: 'Дата должна быть раньше даты последнего слота'
            },
            fromDateLarger: {
              method: fromDateLarger,
              error: 'Дата начала должна быть меньше даты окончания'
            },
            isFuture: {
              method: isFuture,
              error: 'Дата должна быть в будущем'
            }
          }
        },
        slotEnd: {
          value: '',
          validator: {
            required,
            toDateUnder: {
              method: toDateUnder,
              error: 'Дата начала должна быть больше даты начала'
            },
            isFuture: {
              method: isFuture,
              error: 'Дата должна быть в будущем'
            },
            isToUnderLastPoint: {
              method: isToUnderLastPoint,
              error: 'Дата должна быть раньше даты последнего слота'
            }
          }
        },
        prevPoint: {
          value: () => _self.prevPoint
        },
        points: {
          value: () => _self.points
        }
      }
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.fileUuid = null
        return
      }

      try {
        await api.files.postFile({ uuid: data.uuid, file: data.file })
        this.formData.fileUuid = data.uuid
      } catch (e) {
        console.log(e)
      }
    },
    async onSubmitHandler (data) {
      try {
        this.isLoading = true
        await api.orderProcess.changeSlot({
          ...data,
          uuid: this.dataSource.suborderUuid,
          point_uuid: this.dataSource.visitPointUuid
        })
        this.$emit('submit')
      } catch (e) {
        console.log(e)
      } finally {
        this.isLoading = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
</style>
